<html>
<head>
<title>OgreTerrainMaterialGenerator.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_f1fa7196649e3987904dbdb4948bc856.html">Components</a>      </li>
      <li class="navelem"><a class="el" href="dir_6cd0971983c3e0e5b0cb362e5db7fc9d.html">Terrain</a>      </li>
      <li class="navelem"><a class="el" href="dir_9b506231b651991d884bb23d993d7984.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreTerrainMaterialGenerator.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreTerrainMaterialGenerator_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __Ogre_TerrainMaterialGenerator_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __Ogre_TerrainMaterialGenerator_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreTerrainPrerequisites_8h.html">OgreTerrainPrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgrePixelFormat_8h.html">OgrePixelFormat.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreMaterial_8h.html">OgreMaterial.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreTexture_8h.html">OgreTexture.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Ogre
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039     <span class="keyword">class </span>Terrain;
<a name="l00040"></a>00040 
<a name="l00056"></a><a class="code" href="group__Terrain.html#gad6e8e88c8f2109b45648fd6f3ec00a84">00056</a>     <span class="keyword">enum</span> <a class="code" href="group__Terrain.html#gad6e8e88c8f2109b45648fd6f3ec00a84" title="Enumeration of types of data that can be read from textures that are specific to a given layer...">TerrainLayerSamplerSemantic</a>
<a name="l00057"></a>00057     {
<a name="l00059"></a><a class="code" href="group__Terrain.html#ggad6e8e88c8f2109b45648fd6f3ec00a84a6407050de320fbf7c06c77bb97e647e7">00059</a>         <a class="code" href="group__Terrain.html#ggad6e8e88c8f2109b45648fd6f3ec00a84a6407050de320fbf7c06c77bb97e647e7" title="Albedo colour (diffuse reflectance colour)">TLSS_ALBEDO</a> = 0,
<a name="l00061"></a><a class="code" href="group__Terrain.html#ggad6e8e88c8f2109b45648fd6f3ec00a84ae90f168a77e4047af27e14ca52d8205a">00061</a>         <a class="code" href="group__Terrain.html#ggad6e8e88c8f2109b45648fd6f3ec00a84ae90f168a77e4047af27e14ca52d8205a" title="Tangent-space normal information from a detail texture.">TLSS_NORMAL</a> = 1,
<a name="l00063"></a><a class="code" href="group__Terrain.html#ggad6e8e88c8f2109b45648fd6f3ec00a84adeb418649d89cf961e3f60b009a5e5fb">00063</a>         <a class="code" href="group__Terrain.html#ggad6e8e88c8f2109b45648fd6f3ec00a84adeb418649d89cf961e3f60b009a5e5fb" title="Height information for the detail texture.">TLSS_HEIGHT</a> = 2,
<a name="l00065"></a><a class="code" href="group__Terrain.html#ggad6e8e88c8f2109b45648fd6f3ec00a84ae7b29f10d891aac2a3e41c71f7fa96c7">00065</a>         <a class="code" href="group__Terrain.html#ggad6e8e88c8f2109b45648fd6f3ec00a84ae7b29f10d891aac2a3e41c71f7fa96c7" title="Specular reflectance.">TLSS_SPECULAR</a> = 3
<a name="l00066"></a>00066     };
<a name="l00067"></a>00067 
<a name="l00070"></a><a class="code" href="structOgre_1_1TerrainLayerSamplerElement.html">00070</a>     <span class="keyword">struct </span><a class="code" href="OgreTerrainPrerequisites_8h.html#a2fbe49b54cb4b3c3e2757cd3ac167068">_OgreTerrainExport</a> <a class="code" href="structOgre_1_1TerrainLayerSamplerElement.html" title="Information about one element of a sampler / texture within a layer.">TerrainLayerSamplerElement</a>
<a name="l00071"></a>00071     {
<a name="l00073"></a><a class="code" href="structOgre_1_1TerrainLayerSamplerElement.html#a96b4bc009cc033a8b6d5c32aaffd2bbd">00073</a>         <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> <a class="code" href="structOgre_1_1TerrainLayerSamplerElement.html#a96b4bc009cc033a8b6d5c32aaffd2bbd" title="The source sampler index of this element relative to LayerDeclaration&#39;s list.">source</a>;
<a name="l00075"></a><a class="code" href="structOgre_1_1TerrainLayerSamplerElement.html#afd77757659bd8b5f5672a34168071963">00075</a>         <a class="code" href="group__Terrain.html#gad6e8e88c8f2109b45648fd6f3ec00a84" title="Enumeration of types of data that can be read from textures that are specific to a given layer...">TerrainLayerSamplerSemantic</a> <a class="code" href="structOgre_1_1TerrainLayerSamplerElement.html#afd77757659bd8b5f5672a34168071963" title="The semantic this element represents.">semantic</a>;
<a name="l00077"></a><a class="code" href="structOgre_1_1TerrainLayerSamplerElement.html#a82f5e76d137cfc061c99fa1458a2abb4">00077</a>         <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> <a class="code" href="structOgre_1_1TerrainLayerSamplerElement.html#a82f5e76d137cfc061c99fa1458a2abb4" title="The colour element at which this element starts.">elementStart</a>;
<a name="l00079"></a><a class="code" href="structOgre_1_1TerrainLayerSamplerElement.html#a1f5544d50fad51034e72258400eb561b">00079</a>         <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> <a class="code" href="structOgre_1_1TerrainLayerSamplerElement.html#a1f5544d50fad51034e72258400eb561b" title="The number of colour elements this semantic uses (usually standard per semantic)">elementCount</a>;
<a name="l00080"></a>00080 
<a name="l00081"></a><a class="code" href="structOgre_1_1TerrainLayerSamplerElement.html#af5cd2fe83ba44cc3774091340e12da86">00081</a>         <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#gaa5b83b2ba3ce965e3d8dd129c93ee43b" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator==</a>(<span class="keyword">const</span> <a class="code" href="structOgre_1_1TerrainLayerSamplerElement.html" title="Information about one element of a sampler / texture within a layer.">TerrainLayerSamplerElement</a>&amp; e)<span class="keyword"> const</span>
<a name="l00082"></a>00082 <span class="keyword">        </span>{
<a name="l00083"></a>00083             <span class="keywordflow">return</span> source == e.<a class="code" href="structOgre_1_1TerrainLayerSamplerElement.html#a96b4bc009cc033a8b6d5c32aaffd2bbd" title="The source sampler index of this element relative to LayerDeclaration&#39;s list.">source</a> &amp;&amp;
<a name="l00084"></a>00084                 semantic == e.<a class="code" href="structOgre_1_1TerrainLayerSamplerElement.html#afd77757659bd8b5f5672a34168071963" title="The semantic this element represents.">semantic</a> &amp;&amp;
<a name="l00085"></a>00085                 elementStart == e.<a class="code" href="structOgre_1_1TerrainLayerSamplerElement.html#a82f5e76d137cfc061c99fa1458a2abb4" title="The colour element at which this element starts.">elementStart</a> &amp;&amp;
<a name="l00086"></a>00086                 elementCount == e.<a class="code" href="structOgre_1_1TerrainLayerSamplerElement.html#a1f5544d50fad51034e72258400eb561b" title="The number of colour elements this semantic uses (usually standard per semantic)">elementCount</a>;
<a name="l00087"></a>00087         }
<a name="l00088"></a>00088 
<a name="l00089"></a><a class="code" href="structOgre_1_1TerrainLayerSamplerElement.html#af648e0695b3baa049d586e82e2194e1f">00089</a>         <a class="code" href="structOgre_1_1TerrainLayerSamplerElement.html#af648e0695b3baa049d586e82e2194e1f">TerrainLayerSamplerElement</a>() {}
<a name="l00090"></a><a class="code" href="structOgre_1_1TerrainLayerSamplerElement.html#ae471dccbe80e8580b943b3883e40b571">00090</a>         <a class="code" href="structOgre_1_1TerrainLayerSamplerElement.html" title="Information about one element of a sampler / texture within a layer.">TerrainLayerSamplerElement</a>(<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> src, <a class="code" href="group__Terrain.html#gad6e8e88c8f2109b45648fd6f3ec00a84" title="Enumeration of types of data that can be read from textures that are specific to a given layer...">TerrainLayerSamplerSemantic</a> sem,
<a name="l00091"></a>00091             <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> elemStart, <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> elemCount)
<a name="l00092"></a>00092             : source(src), semantic(sem), elementStart(elemStart), elementCount(elemCount)
<a name="l00093"></a>00093         {
<a name="l00094"></a>00094         }
<a name="l00095"></a>00095     };
<a name="l00096"></a><a class="code" href="group__Terrain.html#gaed5c69e4a57dade51d33e835d0702660">00096</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;TerrainLayerSamplerElement&gt;::type</a> <a class="code" href="group__Terrain.html#gaed5c69e4a57dade51d33e835d0702660">TerrainLayerSamplerElementList</a>;
<a name="l00097"></a>00097 
<a name="l00100"></a><a class="code" href="structOgre_1_1TerrainLayerSampler.html">00100</a>     <span class="keyword">struct </span><a class="code" href="OgreTerrainPrerequisites_8h.html#a2fbe49b54cb4b3c3e2757cd3ac167068">_OgreTerrainExport</a> <a class="code" href="structOgre_1_1TerrainLayerSampler.html" title="Description of a sampler that will be used with each layer.">TerrainLayerSampler</a>
<a name="l00101"></a>00101     {
<a name="l00103"></a><a class="code" href="structOgre_1_1TerrainLayerSampler.html#ade7747cc8625094da5ed01bc5ab3e19c">00103</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="structOgre_1_1TerrainLayerSampler.html#ade7747cc8625094da5ed01bc5ab3e19c" title="A descriptive name that is merely used to assist in recognition.">alias</a>;
<a name="l00105"></a><a class="code" href="structOgre_1_1TerrainLayerSampler.html#acbf57cf471d575ffc862c50d15bad9b0">00105</a>         <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> <a class="code" href="structOgre_1_1TerrainLayerSampler.html#acbf57cf471d575ffc862c50d15bad9b0" title="The format required of this texture.">format</a>;
<a name="l00106"></a>00106 
<a name="l00107"></a><a class="code" href="structOgre_1_1TerrainLayerSampler.html#a2bba3b847c3ca420a706a762f05d21ba">00107</a>         <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#gaa5b83b2ba3ce965e3d8dd129c93ee43b" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator==</a>(<span class="keyword">const</span> <a class="code" href="structOgre_1_1TerrainLayerSampler.html" title="Description of a sampler that will be used with each layer.">TerrainLayerSampler</a>&amp; s)<span class="keyword"> const</span>
<a name="l00108"></a>00108 <span class="keyword">        </span>{
<a name="l00109"></a>00109             <span class="keywordflow">return</span> alias == s.<a class="code" href="structOgre_1_1TerrainLayerSampler.html#ade7747cc8625094da5ed01bc5ab3e19c" title="A descriptive name that is merely used to assist in recognition.">alias</a> &amp;&amp; format == s.<a class="code" href="structOgre_1_1TerrainLayerSampler.html#acbf57cf471d575ffc862c50d15bad9b0" title="The format required of this texture.">format</a>;
<a name="l00110"></a>00110         }
<a name="l00111"></a>00111 
<a name="l00112"></a><a class="code" href="structOgre_1_1TerrainLayerSampler.html#a8cf27ef7b384897c434ea13670fb3231">00112</a>         <a class="code" href="structOgre_1_1TerrainLayerSampler.html#a8cf27ef7b384897c434ea13670fb3231">TerrainLayerSampler</a>() {}
<a name="l00113"></a>00113 
<a name="l00114"></a><a class="code" href="structOgre_1_1TerrainLayerSampler.html#a99aefff53a235d471bb54d65c8ec0483">00114</a>         <a class="code" href="structOgre_1_1TerrainLayerSampler.html" title="Description of a sampler that will be used with each layer.">TerrainLayerSampler</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; aliasName, <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> fmt)
<a name="l00115"></a>00115             : alias(aliasName), format(fmt)
<a name="l00116"></a>00116         {
<a name="l00117"></a>00117         }
<a name="l00118"></a>00118     };
<a name="l00119"></a><a class="code" href="group__Terrain.html#gadf90591c883d93190405f52ca11ef600">00119</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;TerrainLayerSampler&gt;::type</a> <a class="code" href="group__Terrain.html#gadf90591c883d93190405f52ca11ef600">TerrainLayerSamplerList</a>;
<a name="l00120"></a>00120 
<a name="l00125"></a><a class="code" href="structOgre_1_1TerrainLayerDeclaration.html">00125</a>     <span class="keyword">struct </span><a class="code" href="OgreTerrainPrerequisites_8h.html#a2fbe49b54cb4b3c3e2757cd3ac167068">_OgreTerrainExport</a> <a class="code" href="structOgre_1_1TerrainLayerDeclaration.html" title="The definition of the information each layer will contain in this terrain.">TerrainLayerDeclaration</a>
<a name="l00126"></a>00126     {
<a name="l00127"></a><a class="code" href="structOgre_1_1TerrainLayerDeclaration.html#a3beefe92183cb240f5810553909f7bde">00127</a>         <a class="code" href="group__Terrain.html#gadf90591c883d93190405f52ca11ef600">TerrainLayerSamplerList</a> <a class="code" href="structOgre_1_1TerrainLayerDeclaration.html#a3beefe92183cb240f5810553909f7bde">samplers</a>;
<a name="l00128"></a><a class="code" href="structOgre_1_1TerrainLayerDeclaration.html#a4eaf6c95757b0031e0e7191632bb4fd0">00128</a>         <a class="code" href="group__Terrain.html#gaed5c69e4a57dade51d33e835d0702660">TerrainLayerSamplerElementList</a> <a class="code" href="structOgre_1_1TerrainLayerDeclaration.html#a4eaf6c95757b0031e0e7191632bb4fd0">elements</a>;
<a name="l00129"></a>00129 
<a name="l00130"></a><a class="code" href="structOgre_1_1TerrainLayerDeclaration.html#a14a97c038823d9e5dab43d9a2d9d432d">00130</a>         <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#gaa5b83b2ba3ce965e3d8dd129c93ee43b" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator==</a>(<span class="keyword">const</span> <a class="code" href="structOgre_1_1TerrainLayerDeclaration.html" title="The definition of the information each layer will contain in this terrain.">TerrainLayerDeclaration</a>&amp; dcl)<span class="keyword"> const</span>
<a name="l00131"></a>00131 <span class="keyword">        </span>{
<a name="l00132"></a>00132             <span class="keywordflow">return</span> samplers == dcl.<a class="code" href="structOgre_1_1TerrainLayerDeclaration.html#a3beefe92183cb240f5810553909f7bde">samplers</a> &amp;&amp; elements == dcl.<a class="code" href="structOgre_1_1TerrainLayerDeclaration.html#a4eaf6c95757b0031e0e7191632bb4fd0">elements</a>;
<a name="l00133"></a>00133         }
<a name="l00134"></a>00134     };
<a name="l00135"></a>00135 
<a name="l00155"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator.html">00155</a>     <span class="keyword">class </span><a class="code" href="OgreTerrainPrerequisites_8h.html#a2fbe49b54cb4b3c3e2757cd3ac167068">_OgreTerrainExport</a> <a class="code" href="classOgre_1_1TerrainMaterialGenerator.html" title="Class that provides functionality to generate materials for use with a terrain.">TerrainMaterialGenerator</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">TerrainAlloc</a>
<a name="l00156"></a>00156     {
<a name="l00157"></a>00157     <span class="keyword">public</span>:
<a name="l00161"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html">00161</a>         <span class="keyword">class </span><a class="code" href="OgreTerrainPrerequisites_8h.html#a2fbe49b54cb4b3c3e2757cd3ac167068">_OgreTerrainExport</a> <a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html" title="Inner class which should also be subclassed to provide profile-specific material generation.">Profile</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">TerrainAlloc</a>
<a name="l00162"></a>00162         {
<a name="l00163"></a>00163         <span class="keyword">protected</span>:
<a name="l00164"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html#a869235f68fd7821067b41f3946e0f5ef">00164</a>             <a class="code" href="classOgre_1_1TerrainMaterialGenerator.html" title="Class that provides functionality to generate materials for use with a terrain.">TerrainMaterialGenerator</a>* <a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html#a869235f68fd7821067b41f3946e0f5ef">mParent</a>;
<a name="l00165"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html#acd101ecd87f04e8d313834f8da1aee4e">00165</a>             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html#acd101ecd87f04e8d313834f8da1aee4e">mName</a>;
<a name="l00166"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html#af9df01eba06dc39bf4f943e80ed2f197">00166</a>             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html#af9df01eba06dc39bf4f943e80ed2f197">mDesc</a>;
<a name="l00167"></a>00167         <span class="keyword">public</span>:
<a name="l00168"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html#aed78c492593089c072d6adf0d241fd10">00168</a>             <a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html" title="Inner class which should also be subclassed to provide profile-specific material generation.">Profile</a>(<a class="code" href="classOgre_1_1TerrainMaterialGenerator.html" title="Class that provides functionality to generate materials for use with a terrain.">TerrainMaterialGenerator</a>* parent, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; desc)
<a name="l00169"></a>00169                 : mParent(parent), mName(name), mDesc(desc) {}
<a name="l00170"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html#a8b8528902ca05c44ce41a4a4802f0769">00170</a>             <a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html" title="Inner class which should also be subclassed to provide profile-specific material generation.">Profile</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html" title="Inner class which should also be subclassed to provide profile-specific material generation.">Profile</a>&amp; prof) 
<a name="l00171"></a>00171                 : mParent(prof.mParent), mName(prof.mName), mDesc(prof.mDesc) {}
<a name="l00172"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html#a0f8e8543ce925703ccc57298a9b59ffa">00172</a>             <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html#a0f8e8543ce925703ccc57298a9b59ffa">~Profile</a>() {}
<a name="l00174"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html#aeaae7ac474e9755ab4f49a989bdcbfa6">00174</a>             <a class="code" href="classOgre_1_1TerrainMaterialGenerator.html" title="Class that provides functionality to generate materials for use with a terrain.">TerrainMaterialGenerator</a>* <a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html#aeaae7ac474e9755ab4f49a989bdcbfa6" title="Get the generator which owns this profile.">getParent</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mParent; }
<a name="l00176"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html#ac775f704382e9dea4a7f0a49b1d6dab9">00176</a>             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html#ac775f704382e9dea4a7f0a49b1d6dab9" title="Get the name of this profile.">getName</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mName; }
<a name="l00178"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html#ad89f2285a2c59643d0127bc9801d8ecb">00178</a>             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html#ad89f2285a2c59643d0127bc9801d8ecb" title="Get the description of this profile.">getDescription</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mDesc; }
<a name="l00180"></a>00180             <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isVertexCompressionSupported() <span class="keyword">const</span> = 0;      
<a name="l00182"></a>00182             <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> generate(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain) = 0;
<a name="l00184"></a>00184             <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> generateForCompositeMap(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain) = 0;
<a name="l00186"></a>00186             <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> getMaxLayers(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain) <span class="keyword">const</span> = 0;
<a name="l00188"></a>00188             <span class="keyword">virtual</span> <span class="keywordtype">void</span> updateCompositeMap(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <span class="keyword">const</span> <a class="code" href="structOgre_1_1TRect.html">Rect</a>&amp; rect);
<a name="l00189"></a>00189 
<a name="l00191"></a>00191             <span class="keyword">virtual</span> <span class="keywordtype">void</span> updateParams(<span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; mat, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain) = 0;
<a name="l00193"></a>00193             <span class="keyword">virtual</span> <span class="keywordtype">void</span> updateParamsForCompositeMap(<span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; mat, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain) = 0;
<a name="l00194"></a>00194 
<a name="l00196"></a>00196             <span class="keyword">virtual</span> <span class="keywordtype">void</span> requestOptions(<a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain) = 0;
<a name="l00197"></a>00197 
<a name="l00198"></a>00198         };
<a name="l00199"></a>00199 
<a name="l00200"></a>00200         <a class="code" href="classOgre_1_1TerrainMaterialGenerator.html" title="Class that provides functionality to generate materials for use with a terrain.">TerrainMaterialGenerator</a>();
<a name="l00201"></a>00201         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1TerrainMaterialGenerator.html" title="Class that provides functionality to generate materials for use with a terrain.">TerrainMaterialGenerator</a>();
<a name="l00202"></a>00202 
<a name="l00204"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#a337b92bbdb7651a87c2deaaabfee61bd">00204</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;Profile*&gt;::type</a> <a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#a337b92bbdb7651a87c2deaaabfee61bd" title="List of profiles - NB should be ordered in descending complexity.">ProfileList</a>;
<a name="l00205"></a>00205     
<a name="l00208"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#a08984aa8f2a4c681a382160853961280">00208</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#a337b92bbdb7651a87c2deaaabfee61bd" title="List of profiles - NB should be ordered in descending complexity.">ProfileList</a>&amp; <a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#a08984aa8f2a4c681a382160853961280" title="Get the list of profiles that this generator supports.">getProfiles</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mProfiles; }
<a name="l00209"></a>00209 
<a name="l00211"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#aaf1237c1f7b754f2c4d1d172c7690508">00211</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setActiveProfile(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name)
<a name="l00212"></a>00212         {
<a name="l00213"></a>00213             <span class="keywordflow">if</span> (!mActiveProfile || mActiveProfile-&gt;getName() != name)
<a name="l00214"></a>00214             {
<a name="l00215"></a>00215                 <span class="keywordflow">for</span> (ProfileList::iterator i = mProfiles.begin(); i != mProfiles.end(); ++i)
<a name="l00216"></a>00216                 {
<a name="l00217"></a>00217                     <span class="keywordflow">if</span> ((*i)-&gt;getName() == name)
<a name="l00218"></a>00218                     {
<a name="l00219"></a>00219                         setActiveProfile(*i);
<a name="l00220"></a>00220                         <span class="keywordflow">break</span>;
<a name="l00221"></a>00221                     }
<a name="l00222"></a>00222                 }
<a name="l00223"></a>00223             }
<a name="l00224"></a>00224 
<a name="l00225"></a>00225         }
<a name="l00226"></a>00226 
<a name="l00228"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#a0580472a86a3c9cadfe6c494e5005854">00228</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setActiveProfile(<a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html" title="Inner class which should also be subclassed to provide profile-specific material generation.">Profile</a>* p)
<a name="l00229"></a>00229         {
<a name="l00230"></a>00230             <span class="keywordflow">if</span> (mActiveProfile != p)
<a name="l00231"></a>00231             {
<a name="l00232"></a>00232                 mActiveProfile = p;
<a name="l00233"></a>00233                 _markChanged();
<a name="l00234"></a>00234             }
<a name="l00235"></a>00235         }
<a name="l00237"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#a123e89e77062269eb86d4ad09567b5cb">00237</a>         <a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html" title="Inner class which should also be subclassed to provide profile-specific material generation.">Profile</a>* getActiveProfile()<span class="keyword"> const </span>
<a name="l00238"></a>00238 <span class="keyword">        </span>{ 
<a name="l00239"></a>00239             <span class="comment">// default if not chosen yet</span>
<a name="l00240"></a>00240             <span class="keywordflow">if</span> (!mActiveProfile &amp;&amp; !mProfiles.empty())
<a name="l00241"></a>00241                 mActiveProfile = mProfiles[0];
<a name="l00242"></a>00242 
<a name="l00243"></a>00243             <span class="keywordflow">return</span> mActiveProfile; 
<a name="l00244"></a>00244         }
<a name="l00245"></a>00245 
<a name="l00247"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#ae6cdf5dafc5bbea8e8241b54689798de">00247</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#ae6cdf5dafc5bbea8e8241b54689798de" title="Internal method - indicates that a change has been made that would require material regeneration...">_markChanged</a>() { ++mChangeCounter; }
<a name="l00248"></a>00248 
<a name="l00252"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#a2582ef7b74f57c667dd9141b4d7ce770">00252</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <span class="keywordtype">long</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#a2582ef7b74f57c667dd9141b4d7ce770" title="Returns the number of times the generator has undergone a change which would require materials to be ...">getChangeCount</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mChangeCounter; }
<a name="l00253"></a>00253 
<a name="l00256"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#a2b588f2e356379764c372ae4c1318b3c">00256</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="structOgre_1_1TerrainLayerDeclaration.html" title="The definition of the information each layer will contain in this terrain.">TerrainLayerDeclaration</a>&amp; <a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#a2b588f2e356379764c372ae4c1318b3c" title="Get the layer declaration that this material generator operates with.">getLayerDeclaration</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mLayerDecl; }
<a name="l00263"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#a7f9892827501c4907da1775e3c0c067b">00263</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> canGenerateUsingDeclaration(<span class="keyword">const</span> <a class="code" href="structOgre_1_1TerrainLayerDeclaration.html" title="The definition of the information each layer will contain in this terrain.">TerrainLayerDeclaration</a>&amp; decl)
<a name="l00264"></a>00264         {
<a name="l00265"></a>00265             <span class="keywordflow">return</span> decl == mLayerDecl;
<a name="l00266"></a>00266         }
<a name="l00267"></a>00267         
<a name="l00271"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#ab31900b86aac80a5ac2fd040219f1932">00271</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isVertexCompressionSupported()<span class="keyword"> const</span>
<a name="l00272"></a>00272 <span class="keyword">        </span>{
<a name="l00273"></a>00273             <span class="keywordflow">return</span> getActiveProfile()-&gt;isVertexCompressionSupported();
<a name="l00274"></a>00274         }
<a name="l00275"></a>00275 
<a name="l00278"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#af56363e3dbbffde7872cf88b869565ac">00278</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> requestOptions(<a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain)
<a name="l00279"></a>00279         {
<a name="l00280"></a>00280             <a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html" title="Inner class which should also be subclassed to provide profile-specific material generation.">Profile</a>* p = getActiveProfile();
<a name="l00281"></a>00281             <span class="keywordflow">if</span> (p)
<a name="l00282"></a>00282                 p-&gt;<a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html#ad4cbd3a430cdf5ce892ab63ef8ad270b" title="Request the options needed from the terrain.">requestOptions</a>(terrain);
<a name="l00283"></a>00283 
<a name="l00284"></a>00284         }
<a name="l00287"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#aa9e7fb7cee77cc1bb1d88fa6c3de7f5e">00287</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> generate(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain)
<a name="l00288"></a>00288         {
<a name="l00289"></a>00289             <a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html" title="Inner class which should also be subclassed to provide profile-specific material generation.">Profile</a>* p = getActiveProfile();
<a name="l00290"></a>00290             <span class="keywordflow">if</span> (!p)
<a name="l00291"></a>00291                 <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>();
<a name="l00292"></a>00292             <span class="keywordflow">else</span>
<a name="l00293"></a>00293                 <span class="keywordflow">return</span> p-&gt;<a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html#a0c47702015bcc5ad4a4920d02a67da2b" title="Generate / resuse a material for the terrain.">generate</a>(terrain);
<a name="l00294"></a>00294         }
<a name="l00297"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#acaa6cd4b06a385638fed2603480d8445">00297</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> generateForCompositeMap(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain)
<a name="l00298"></a>00298         {
<a name="l00299"></a>00299             <a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html" title="Inner class which should also be subclassed to provide profile-specific material generation.">Profile</a>* p = getActiveProfile();
<a name="l00300"></a>00300             <span class="keywordflow">if</span> (!p)
<a name="l00301"></a>00301                 <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>();
<a name="l00302"></a>00302             <span class="keywordflow">else</span>
<a name="l00303"></a>00303                 <span class="keywordflow">return</span> p-&gt;<a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html#a70a4e9bf4482762227e48c061759c1d2" title="Generate / resuse a material for the terrain.">generateForCompositeMap</a>(terrain);
<a name="l00304"></a>00304         }
<a name="l00308"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#a6076c32528ca504993081e75b4da9f92">00308</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> getMaxLayers(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain)<span class="keyword"> const</span>
<a name="l00309"></a>00309 <span class="keyword">        </span>{
<a name="l00310"></a>00310             <a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html" title="Inner class which should also be subclassed to provide profile-specific material generation.">Profile</a>* p = getActiveProfile();
<a name="l00311"></a>00311             <span class="keywordflow">if</span> (p)
<a name="l00312"></a>00312                 <span class="keywordflow">return</span> p-&gt;<a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html#a4ab7d26991576153fe480c316ccfef86" title="Get the number of layers supported.">getMaxLayers</a>(terrain);
<a name="l00313"></a>00313             <span class="keywordflow">else</span>
<a name="l00314"></a>00314                 <span class="keywordflow">return</span> 0;
<a name="l00315"></a>00315         }
<a name="l00316"></a>00316 
<a name="l00323"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#aaa151085991db558a3e94748356c8156">00323</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> updateCompositeMap(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <span class="keyword">const</span> <a class="code" href="structOgre_1_1TRect.html">Rect</a>&amp; rect)
<a name="l00324"></a>00324         {
<a name="l00325"></a>00325             <a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html" title="Inner class which should also be subclassed to provide profile-specific material generation.">Profile</a>* p = getActiveProfile();
<a name="l00326"></a>00326             <span class="keywordflow">if</span> (!p)
<a name="l00327"></a>00327                 <span class="keywordflow">return</span>;
<a name="l00328"></a>00328             <span class="keywordflow">else</span>
<a name="l00329"></a>00329                 p-&gt;<a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html#a9bb28eb51fc5229209a72564315d3eb1" title="Update the composite map for a terrain.">updateCompositeMap</a>(terrain, rect);
<a name="l00330"></a>00330         }
<a name="l00331"></a>00331 
<a name="l00332"></a>00332 
<a name="l00335"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#aed0ac64c47fa577fab20e844b02b0aa5">00335</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> updateParams(<span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; mat, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain)
<a name="l00336"></a>00336         {
<a name="l00337"></a>00337             <a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html" title="Inner class which should also be subclassed to provide profile-specific material generation.">Profile</a>* p = getActiveProfile();
<a name="l00338"></a>00338             <span class="keywordflow">if</span> (p)
<a name="l00339"></a>00339                 p-&gt;<a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html#a8efea3f1c4506d600d96995ba0d61164" title="Update params for a terrain.">updateParams</a>(mat, terrain);
<a name="l00340"></a>00340         }
<a name="l00343"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#a15db830ec2609de8e70e90861a30b8a7">00343</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> updateParamsForCompositeMap(<span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; mat, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain)
<a name="l00344"></a>00344         {
<a name="l00345"></a>00345             <a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html" title="Inner class which should also be subclassed to provide profile-specific material generation.">Profile</a>* p = getActiveProfile();
<a name="l00346"></a>00346             <span class="keywordflow">if</span> (p)
<a name="l00347"></a>00347                 p-&gt;<a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html#abcb1087d4d2f5b60ba99a22a86dde5f4" title="Update params for a terrain.">updateParamsForCompositeMap</a>(mat, terrain);
<a name="l00348"></a>00348         }
<a name="l00349"></a>00349 
<a name="l00358"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#acfbb5218a477deb4065d0eadd8c1f0c3">00358</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setDebugLevel(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dbg)
<a name="l00359"></a>00359         {
<a name="l00360"></a>00360             <span class="keywordflow">if</span> (mDebugLevel != dbg)
<a name="l00361"></a>00361             {
<a name="l00362"></a>00362                 mDebugLevel = dbg;
<a name="l00363"></a>00363                 _markChanged();
<a name="l00364"></a>00364             }
<a name="l00365"></a>00365         }
<a name="l00367"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#ab48af2c30f6b4e04b7f0f33145ebca7f">00367</a>         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#ab48af2c30f6b4e04b7f0f33145ebca7f" title="Get the debug level of the material.">getDebugLevel</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mDebugLevel; }
<a name="l00368"></a>00368 
<a name="l00376"></a>00376         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _renderCompositeMap(<span class="keywordtype">size_t</span> size, <span class="keyword">const</span> <a class="code" href="structOgre_1_1TRect.html">Rect</a>&amp; rect, 
<a name="l00377"></a>00377             <span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; mat, <span class="keyword">const</span> <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a>&amp; destCompositeMap);
<a name="l00378"></a>00378 
<a name="l00379"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#a87dca7208407e824a01d5e07ea92688f">00379</a>         <a class="code" href="classOgre_1_1Texture.html" title="Abstract class representing a Texture resource.">Texture</a>* <a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#a87dca7208407e824a01d5e07ea92688f">_getCompositeMapRTT</a>() { <span class="keywordflow">return</span> mCompositeMapRTT; }
<a name="l00380"></a>00380     <span class="keyword">protected</span>:
<a name="l00381"></a>00381 
<a name="l00382"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#acdbc4cf5bdba5c6577662581c2d9c990">00382</a>         <a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#a337b92bbdb7651a87c2deaaabfee61bd" title="List of profiles - NB should be ordered in descending complexity.">ProfileList</a> <a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#acdbc4cf5bdba5c6577662581c2d9c990">mProfiles</a>;
<a name="l00383"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#a0f04fb94223347d560338399f2fa2cd0">00383</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html" title="Inner class which should also be subclassed to provide profile-specific material generation.">Profile</a>* <a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#a0f04fb94223347d560338399f2fa2cd0">mActiveProfile</a>;
<a name="l00384"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#ab21a210743846b8dd20799f4324fb882">00384</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <span class="keywordtype">long</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#ab21a210743846b8dd20799f4324fb882">mChangeCounter</a>;
<a name="l00385"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#a7c256bc180f216bb90f594d3698963a4">00385</a>         <a class="code" href="structOgre_1_1TerrainLayerDeclaration.html" title="The definition of the information each layer will contain in this terrain.">TerrainLayerDeclaration</a> <a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#a7c256bc180f216bb90f594d3698963a4">mLayerDecl</a>;
<a name="l00386"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#ae58d5426a1d4de2fecece9efecc00834">00386</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#ae58d5426a1d4de2fecece9efecc00834">mDebugLevel</a>;
<a name="l00387"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#a68016a45555fc8c772c76532d1a74aa9">00387</a>         <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* <a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#a68016a45555fc8c772c76532d1a74aa9">mCompositeMapSM</a>;
<a name="l00388"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#afb78d081851dbb6945ff07c9c33d48c9">00388</a>         <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* <a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#afb78d081851dbb6945ff07c9c33d48c9">mCompositeMapCam</a>;
<a name="l00389"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#a85b957996602677758e0ceec23e5bfcc">00389</a>         <a class="code" href="classOgre_1_1Texture.html" title="Abstract class representing a Texture resource.">Texture</a>* <a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#a85b957996602677758e0ceec23e5bfcc">mCompositeMapRTT</a>; <span class="comment">// deliberately holding this by raw pointer to avoid shutdown issues</span>
<a name="l00390"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#abc10291e0f1514a0964f8f5b090efd67">00390</a>         <a class="code" href="classOgre_1_1ManualObject.html" title="Class providing a much simplified interface to generating manual objects with custom geometry...">ManualObject</a>* <a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#abc10291e0f1514a0964f8f5b090efd67">mCompositeMapPlane</a>;
<a name="l00391"></a><a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#a537affac1f06bed1d3a5c0d42c6dcd2b">00391</a>         <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a>* <a class="code" href="classOgre_1_1TerrainMaterialGenerator.html#a537affac1f06bed1d3a5c0d42c6dcd2b">mCompositeMapLight</a>;
<a name="l00392"></a>00392 
<a name="l00393"></a>00393 
<a name="l00394"></a>00394 
<a name="l00395"></a>00395     };
<a name="l00396"></a>00396 
<a name="l00397"></a><a class="code" href="group__Terrain.html#ga152d33cadca984511f2c0459562c7b0b">00397</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1SharedPtr.html">SharedPtr&lt;TerrainMaterialGenerator&gt;</a> <a class="code" href="group__Terrain.html#ga152d33cadca984511f2c0459562c7b0b">TerrainMaterialGeneratorPtr</a>;
<a name="l00398"></a>00398 
<a name="l00402"></a>00402 }
<a name="l00403"></a>00403 <span class="preprocessor">#endif</span>
<a name="l00404"></a>00404 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
